C     -------------------------------------------------------------------------
C     matrix multiplication
C
C     1. compile with automatic parallelization and highest reporting level
C
C       ifort -O3 -parallel -par-report3 matmult.f -o matmult
C
C     2. set number of threads and prohibit dynamic adjustment of number
C
C       export set OMP_DYNAMIC=FALSE
C       export set OMP_NUM_THREADS=<number of threads>
C
C     3. prepare runtime monitoring in other window showng all threads
C
C       top -u <username> -H 
C
C     3. execute with timing switched on
C
C       time ./matmult
C
C     -------------------------------------------------------------------------
      PROGRAM main
C
      INTEGER N, I, J, K
      PARAMETER (N = 4096) 
C
      REAL A(N,N), B(N,N), C(N,N)
C
      DO I=1,N
         DO J=1,N
            C(I,J) = 0
            DO K=1,N
               C(I,J) = C(I,J)+A(I,K)*B(K,j)
            ENDDO
         ENDDO
      ENDDO
C
      DO I=1,N
        DO J=1,N    
C         PRINT *, C(I,J)
        ENDDO
      ENDDO
C
      END
